package praktikum04;

import java.awt.desktop.AppHiddenListener;

public class Philosopher implements Runnable{

    protected int id ;
    protected final Fork left;

    protected final Fork right;

    public Philosopher(int id, Fork left, Fork right) {
        this.id = id;
        this.left = left;
        this.right = right;
    }

    @Override
    public void run() {

        allocateForks();
        System.out.println("Philosopher " + id + " is eating");

        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            System.out.println("Philosopher" + id + "was interrupted");
        }
        left.put();
        right.put();

        System.out.println("Philosopher" + id + "is done eating");


    }

    protected void allocateForks() {
        System.out.println("Philosopher" + id + "is trying to get a fork." + left.getId());
        while (!left.take())
            Thread.yield();
        System.out.println("Philosopher" + id + "got fork" + left.getId());
        System.out.println("Philosopher" + id + "is trying to get a fork" + right.getId());
        while (!right.take())
            Thread.yield();
        System.out.println("Philosopher" + id + "got fork" + right.getId());
    }
}
